<template>
    <v-container fluid>
        <v-card :elevation="4" class="ma-3 pa-3">
            <v-layout row wrap>
                <v-autocomplete :items="floors" @input="Update" flat
                                hide-details item-text="name" item-value="id"
                                label="Floor" name="Floor" prepend-inner-icon="$vuetify.icons.floor"
                                solo v-model="floorId"
                />
                <v-spacer/>
                <v-menu :close-on-content-click="false" :return-value.sync="date" offset-y ref="menu"
                        transition="scale-transition" v-model="menu">
                    <template v-slot:activator="{ on, attrs }">
                        <v-text-field flat hide-details label="Day of Analytics"
                                      prepend-inner-icon="$vuetify.icons.event"
                                      readonly solo v-bind="attrs" v-model="date" v-on="on"/>
                    </template>
                    <v-date-picker :allowed-dates="checkDate" :full-width="FullCalendar"
                                   @input="Update" no-title scrollable v-model="date">
                        <v-spacer></v-spacer>
                        <v-btn @click="menu = false" color="primary" text>Cancel</v-btn>
                        <v-btn @click="$refs.menu.save(date)" color="primary" text>OK</v-btn>
                    </v-date-picker>
                </v-menu>
                <v-autocomplete :items="Trades" @input="Update" chips
                                clearable flat hide-details
                                label="Trades" multiple prepend-inner-icon="$vuetify.icons.trade"
                                solo v-model="trade">
                    <template v-slot:selection="{ attrs, item, select, selected }">
                        <v-chip :input-value="selected" @click="select" @click:close="Remove(item)" close
                                v-bind="attrs">
                            <strong>{{ item }}</strong>
                        </v-chip>
                    </template>
                </v-autocomplete>
                <v-select :items="['Bar Chart', 'Heat Map']" @input="Update" flat
                          hide-details item-value="id" label="Chart Type"
                          name="Chart Type" prepend-inner-icon="$vuetify.icons.analytics" solo
                          v-model="chartType"
                />
                <v-select :items="['zone/subcontractor', 'subcontractor/zone']" @input="Update" flat
                          hide-details item-value="id" label="Graph Type"
                          name="Graph Type"
                          prepend-inner-icon="$vuetify.icons.graph" solo
                          v-model="graphType"/>
                <v-select :items="['# of Workers', 'Man Hours']" @input="Update" flat
                          hide-details item-value="id" label="Value Type"
                          name="Value Type"
                          prepend-inner-icon="$vuetify.icons.num" solo
                          v-model="valueType"/>
            </v-layout>
        </v-card>


        <v-container fluid>
            <v-row>
                <div class="parent" style="height:60vh; width: 100%;">
                    <canvas ref="key" v-show="chartType === 'Bar Chart'"/>
                    <HeatMap :h-header="hHeader" :matrix="matrix" :v-header="vHeader" class="mx-auto"
                             id="heatmap" v-show="chartType=== 'Heat Map'">

                    </HeatMap>
                </div>
            </v-row>
        </v-container>
    </v-container>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
    import {Component, Vue} from 'vue-property-decorator';
    import {Mixins} from "vue-mixin-decorator";
    import {Initializable} from "../mixins/Initializable";
    import {Validable} from "../mixins/Validable";
    import {analyticsApi, coreApi, trades} from "../init";
    import {FloorFlyWeightResponse} from "../../../classLibrary/core/floorFlyWeightResponse";
    import Chart from "chart.js";
    import {DataQuery} from "../../../classLibrary/AnalyticsParser";
    import 'moment-duration-format';
    import moment from "moment";
    import {RawLocation} from "vue-router";
    import {HorizontalBar} from "../../../classLibrary/ChartType";
    import HeatMap from "../components/HeatMap.vue";
    import parse from "parse-color";

    type MValue = { style: { background: string }, value: number }

    interface AnalyticsMixin extends Validable, Initializable {
    }

    @Component({
        components: {HeatMap}
    })
    export default class Analytics extends Mixins<AnalyticsMixin>(Validable, Initializable) {

        floorId: string = '';
        floor: FloorFlyWeightResponse = new FloorFlyWeightResponse("", "", "");
        floors: FloorFlyWeightResponse[] = [];

        graphType: string = '';
        valueType: string = '';
        chartType: string = '';
        trade: string[] = [];
        menu: boolean = false;

        allowedDates: string[] = [];
        date: string = '';

        chart!: Chart;

        df: string = "MM-DD-YYYY";

        matrix: MValue[][] = [];
        hHeader: string[] = ['1:00', "2:00", "3:00", "4:00"];
        vHeader: string[] = ['Zone A', "Zone B", "Zone C", "Zone D"];

        get Trades(): string[] {
            return trades;
        }

        get FullCalendar(): boolean {
            const name = this.$vuetify.breakpoint.name;
            return name === "xs" || name == "sm";
        }

        checkDate(val: string): boolean {
            const v = moment((new Date(val))).format(this.df);
            return this.allowedDates
                .Map(x => moment(new Date(x)).format(this.df))
                .Has(v);
        }

        Remove(item: string) {
            this.trade.splice(this.trade.indexOf(item), 1)
            this.trade = [...this.trade]
            this.Update();
        }

        async Update() {

            if (this.floorId === '') {
                await this.$router.push({name: 'analytics-choose'});
                return
            }

            let route: RawLocation = {
                name: 'analytics',
                params: {
                    id: this.floorId
                },
                query: {}
            };

            if (this.valueType != '') route.query!['valueType'] = this.valueType;
            if (this.graphType != '') route.query!['graphType'] = this.graphType;

            if (this.chartType != '') {
                const old = this.$route.query.chartType as string;
                if (old != this.chartType) {
                    this.chart?.destroy();
                    await this.startChart();
                }
                route.query!['chartType'] = this.chartType;
            }
            if (this.date != '') route.query!['date'] = this.date;
            if (this.trade.length != 0) route.query!['trades'] = this.trade.join(",");

            await this.$router.push(route)
        }


        async onMount() {
            await this.startChart();
        }

        async startChart() {
            const chart = this.$refs["key"]! as HTMLCanvasElement;
            if (this.chartType == 'Bar Chart') {
                this.chart = HorizontalBar(chart, this.valueType)
            } else {

            }
        }

        async drawHeadMap(d: DataQuery) {
            const [zones, hours, matrix] = await d.GetHeatMap();


            const color = 'blue';
            const [r, g, b] = parse(color).rgb;
            const max = matrix.Map(x => x.Max()).Max();
            const m = matrix.Map(row => row.Map(x => {
                const total = max === 0 ? 1 : max
                const a = x / total;
                return {
                    style: {
                        background: `rgba(${r},${g},${b},${a})`,
                    },
                    value: x,
                }
            }));

            this.vHeader = zones;
            this.hHeader = hours;
            Vue.set(this, 'matrix', m);
        }

        async drawBarChart(d: DataQuery) {
            const [zs, dataSet] = await d.GetBarChart();

            const c = this.chart as Chart;
            // set labels
            c.data.labels = zs;

            // append datasets
            dataSet.Each((v, i) => {
                if (i >= c.data.datasets?.length!) {
                    c.data.datasets?.push(v);
                } else {
                    c.data.datasets![i].label = v.label;
                    c.data.datasets![i].backgroundColor = v.backgroundColor;
                    c.data.datasets![i].borderColor = v.borderColor;
                    c.data.datasets![i].borderWidth = v.borderWidth;
                    c.data.datasets![i].data = v.data;
                }
            });

            while (c.data.datasets?.length! > dataSet.length) {
                c.data.datasets?.pop();
            }

            c.update();

        }


        async init() {

            // Set parameters from path
            const query = this.$route.query;
            const chartType = query.chartType as any;
            this.valueType = query.valueType as any;
            this.graphType = query.graphType as any;
            this.chartType = chartType;
            this.date = query.date as string ?? '';
            this.trade = (query.trades as (string | null))?.split(",") ?? [];

            // Pull data from API to update
            const fr = await coreApi.Get<FloorFlyWeightResponse[]>('Floor');
            if (!fr.success) {
                this.err = fr.error!;
                return;
            }
            this.floors = fr.Ok!
            const floorId = this.$route.params.id;

            // Check if drawable
            if (floorId != '' && floorId != null && this.date != '' && this.chartType != '' && this.graphType != '') {
                const floor = this.floors.Find(x => x.id == floorId)
                if (floor == null) {
                    await this.$router.push("/notfound");
                } else {
                    this.floorId = floor.id;
                    this.floor = floor;
                    const date = new Date(this.date);
                    const value = this.valueType == 'Man Hours' ? 'seconds' : 'count';
                    const time = this.chartType === 'Bar Chart' ? 'day' : 'hour';
                    const d = new DataQuery(coreApi, analyticsApi, floor.id, date, value, this.trade, time, this.graphType);
                    if (this.chartType == 'Bar Chart') {
                        await this.drawBarChart(d);
                    } else if (this.chartType == 'Heat Map') {
                        await this.drawHeadMap(d);
                    }
                }
            }

            // Pull possible dates for the day itself
            const dateResult = await analyticsApi.Get<string[]>(`Analytics/${this.floorId}/days`)
            if (!dateResult.success) {
                this.err = dateResult.error!;
                return;
            }
            this.allowedDates = dateResult.Ok!

        }
    }
</script>
